/*
* Template-File src/main/takatuka/templates/EntityAbstractSearch.vm
*/
package de.ivu.elect.business.lokalisierung.boundary;

import java.util.List;

import javax.inject.Inject;

import de.ivu.elect.business.lokalisierung.entity.Lokalisierung;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.jee.presentation.search.WildcardConverter;

public abstract class AbstractLokalisierungSearch {

  @Inject
  protected transient LokalisierungExtendedDAO dao;

  public AbstractLokalisierungSearch() {
    super();
  }

  public List<Lokalisierung> getSearchResult(LokalisierungSearchParameters searchParameters, EagerLoadingCollector<Lokalisierung> eagerLoadingCollector) {
    return eagerLoadingCollector.eagerLoad(querySearchResult(searchParameters));
  }

  protected abstract List<Lokalisierung> querySearchResult(LokalisierungSearchParameters searchParameters);

  protected String convertSearchPattern(String patternInput) {
    return new WildcardConverter().addAndConvertToJpqlLikeExpression(patternInput);
  }
}
